require "cgi"

class AMAROK
	# current track information
	def AMAROK::getTitle()
		return `dcop amarok player title`
	end
	def AMAROK::getArtist()
		return `dcop amarok player artist`
	end
	def AMAROK::getAlbum()
		return `dcop amarok player album`
	end
	def AMAROK::getCoverArt()
		return `dcop amarok player coverImage`
	end
	def AMAROK::getPlayCount()
		return `dcop amarok player trackPlayCounter`
	end
	def AMAROK::getComment()
		return `dcop amarok player comment`
	end
	def AMAROK::getScore()
		return `dcop amarok player score`
	end
	def AMAROK::getRating()
		return `dcop amarok player rating`
	end
	
	# collection functions
	def AMAROK::query( sql )	
		sql.gsub!("\"","\\\"")
		`dcop amarok collection query "#{sql}"`
	end
	
	# custom section manipulation
	def AMAROK::addCustomSection( name )
		`dcop amarok contextbrowser addCustomSection "#{name}"`
	end
	def AMAROK::clearCustomSection( name )
		`dcop amarok contextbrowser setCustomSection "#{name}" ""`
	end
	def AMAROK::setCustomSection( name, contents )
		contents.gsub!(" ","%20")
		contents = CGI.escape( contents )
		contents.gsub!("%20"," ")

		`dcop amarok contextbrowser setCustomSection "#{name}" "#{contents}"`
	end
	def AMAROK::setCustomSectionTitle( name, title )
		title.gsub!(" ","%20")
		title = CGI.escape(title)
		title.gsub!("%20"," ")
		
		`dcop amarok contextbrowser setCustomSectionTitle "#{name}" "#{title}"`
	end
	def AMAROK::setCustomSectionContext( name, context )
		`dcop amarok contextbrowser setCustomSectionContext "#{name}" "#{context}"`
	end
	
	# results caching to speed up results
	def AMAROK::setCache( key, contents )
		key = CGI.escape(key)
		home=`cd;pwd`.strip()
		`mkdir #{home}/.kde/share/apps/amarok/scripts-data/cache`
		f = File.open("#{home}/.kde/share/apps/amarok/scripts-data/cache/#{key}.cachefile","w")
		f.puts(contents)
		f.close()
	end
	def AMAROK::getCache( key )
		key = CGI.escape(key)
		home=`cd;pwd`.strip()
		res = `cat "#{home}/.kde/share/apps/amarok/scripts-data/cache/#{key}.cachefile" 2>/dev/null`
		
		if res != nil and res != ""
			return res.strip()
		else
			return ""
		end
	end
end

# extention to the array class to help with query results
class Array
	def group(x)
		final_count = length() / x
		
		idx = 0
		dst_idx = 0
		pos = 0
		dst = []
		final = []
		
		while pos < final_count

			dst[dst_idx] = at(idx)
			
			# advance the iterators
			idx  = idx + 1
			dst_idx = dst_idx + 1
			
			# wrap the desination 
			if dst_idx >= x
				dst_idx = 0
				
				final[pos] = dst
				dst = []
				pos = pos + 1
			end
		end
		
		return final
	end
end