#!/usr/bin/ruby -I/home/teknomunk/.kde/share/apps/amarok/

require "amarok"
require "digest/md5"
require "cgi"

# initilization on load
$sectionName = "1 external_album_info"
AMAROK.addCustomSection( $sectionName )
AMAROK.setCustomSectionContext( $sectionName, "track" )

def niceTime(t)
	seconds = t % 60
	t = ( t - seconds ) / 60
	
	minutes = t % 60
	t = ( t - minutes ) / 60
	
	hours = t % 60
	t = ( t - hours ) / 60
	
	days = t % 24
	t = ( t - days ) / 60
	
	time = ""
	
	if hours != 0 then
		if days != 0 then
			time += "#{days} days "
		end
		
		time += "#{hours}:"
		
		if minutes < 10
			minutes = "0#{minutes}"
		end
	end
	
	if seconds < 10
		seconds = "0#{seconds}"
	end
	
	time += "#{minutes}:#{seconds}"
	
	return time
end

def spreader()
	return "<div style='height:1px;font-size:1px;'>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</div>"
end

def showTrackInfo()
	# the data directory TODO: need to detect from amarok
	datadir = "/usr/share/apps/"
	
	# get the song's information from amarok
	artist = AMAROK.getArtist()
	
	# get the artist's id
	sql = "SELECT album.name,year.name,COUNT(tags.url),SUM(tags.length) FROM tags,artist,album,year WHERE album.id=tags.album and artist.id=tags.artist and artist.name=\"#{artist.strip()}\" and album.name != \"\" and year.id=tags.year GROUP BY album.id"
	albums = AMAROK.query( sql )
	albumsList = albums.strip().split("\n").group(4)
	
	artistID = AMAROK.query( "SELECT id FROM artist WHERE name=\"#{artist.strip()}\"" ).to_i()
	
	# set the section name
	AMAROK.setCustomSectionTitle( $sectionName, "Albums by #{artist}" )
	
	html = ""
	
	# DEBUG: List each album for now
	if albumsList.size() == 0
		AMAROK.setCustomSection( $sectionName, albums )
		return
	end
	
 	idx = 0
	albumsList.each do |item|
		album = item[0]
		year = item[1]
		count = item[2]
		length = item[3]
		
		# query information from the database
		idx = idx + 1
		
		# generate the cover image's digest
		covermd5 = Digest::MD5.hexdigest( "#{artist.downcase().strip()}#{album.downcase().strip()}" )
		
		html += "<table >\n"
		html += "	<tr class='box-row'>\n"
		html +=	"		<td>\n"
		html += "			<div class='album-header' onClick=\"toggleBlock('IDA#{album}#{idx}')\"'>\n"
		html +=	"				<table width='100%' border='0' cellspacing='0' cellpadding='0'>\n"
		html +=	"					<tr>\n"
		html +=	"						<td width='1'>\n"
		html +=	"							<a href='fetchcover:#{artist} @@@ #{CGI.escapeHTML(album)}'>\n"
		html +=	"							<img class='album-image' align='left' vspace='2' hspace='2' title='Image' src='file://#{`echo $HOME`.strip()}/.kde/share/apps/amarok/albumcovers/cache/50@#{covermd5}@shadow'/>\n"
		html +=	"							</a>\n"
		html +=	"						</td>\n"
		html +=	"						<td valign='middle' align='left'>\n"
		#html +=								spreader()
		html +=	"							<span class='album-info'><no br>#{count} Tracks</nobr></span><br>\n"
		html +=	"							<a href='album:1 @@@ 2'><span class='album-title'><nobr>#{CGI.escapeHTML(album)}</nobr></span></a>\n"
		html +=	"							<br />\n"
		html += "							<div><nobr>\n"
		html +=	"								<span class='album-year'>#{year}</span>\n"
		html +=	"								<span class='album-length'> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; #{niceTime(length.to_i())}</span>\n"
		html += "							</nobr></div>\n"
		html +=	"						</td>\n"
		html +=	"					</tr>\n"
		html +=	"				</table>\n"
		html +=	"			</div>\n"
		html +=	"		</td>\n"
		html +=	"	</tr>\n"
		html +=	"</table>\n"
		html += "<div class='album-body' style='display:none;' id='IDA#{album}#{idx}'>\n"
		
		sql = "SELECT tags.title,tags.track,tags.discnumber,tags.album,tags.url,tags.length FROM tags LEFT JOIN album WHERE ( tags.album=album.id or tags.album=0 ) and album.name=\"#{album}\" ORDER BY tags.discnumber,tags.track"
		songs = AMAROK.query( sql ).split("\n").group(6)
		
		curr_disc = ""
		songs.each do |item|
			title = item[0]
			trackno = item[1]
			disc = item[2]
			album = item[3]
			url = item[4]
			length = item[5]
		
			if curr_disc != disc and disc != "0"
				curr_disc = disc
				html += "	<div class='disc-separator'>\n"
				html += "		<a href=\"albumdisc: %1 @@@ %2 @@@ %3\">\n"
				html += "			<nobr>Disc #{curr_disc}</nobr>\n"
				html += "		</a>\n"
				html += "	</div>\n"
			end
			
			trackHTML = "<span class='album-song-trackno'>#{trackno}&nbsp;</span>\n";
			lengthHTML = "(#{niceTime(length.to_i())})"
			
			html += "	<div class='album-song'>\n"
			html += "		<a href=\"file://#{CGI.escapeHTML(url)}\">\n"
			html += "			<nobr>\n"
			html += "				"+trackHTML+"\n"
			html += "				<span class='album-song-title'>#{CGI.escapeHTML(title)}</span>"
			html += "				<span>"+lengthHTML+"</span>\n"
			html += "			</nobr>\n"
			html += "		</a>\n"
			html += "	</div>\n"
			
		end
		
		html += "</div>\n"
	end
	
	AMAROK.setCustomSection( $sectionName, html)
end

# update the information when the script is run
showTrackInfo()

def cleanup()
	#sectionName="1 external_album_info"
	
	puts "Cleanup"
	AMAROK.removeCustomSection( $sectionName)
end

trap( "SIGTERM" ) { cleanup() }

loop do
    message = gets().chomp()
    command = /[A-Za-z]*/.match( message ).to_s()

    case command
    	when "trackChange"
    		showTrackInfo()
    end
end

cleanup