#!/usr/bin/ruby -I/home/teknomunk/.kde/share/apps/amarok/

require "amarok"
require "digest/md5"
require "cgi"

# initilization on load
$sectionName = "2 external_artist_favorites_info"
AMAROK.addCustomSection( $sectionName )
AMAROK.setCustomSectionContext( $sectionName, "track" )

def spreader( x )
	html = "<div style='height:1px;font-size:1pt;'>"
	while x > 0
		html += "&nbsp; "
		x -= 1
	end
	html += "</div>"
	return html;
end

def showTrackInfo()
	# the data directory TODO: need to detect from amarok
	datadir = "/usr/share/apps/"
	
	# get the song's information from amarok
	artist = AMAROK.getArtist()
	
	# get the artist's id
	sql = "SELECT statistics.rating,statistics.percentage,tags.title,tags.url FROM statistics,tags,artist WHERE statistics.url=tags.url and artist.id=tags.artist and artist.name=\"#{artist.strip()}\" GROUP BY tags.url"
	puts sql
	result = AMAROK.query( sql )
	songList = result.strip().split("\n").group(4)
	
	# set the section name
	AMAROK.setCustomSectionTitle( $sectionName, "Favorite Songs by #{artist}" )
	
	html = ""
	
	# DEBUG: List each album for now
	if songList.size() == 0
		AMAROK.clearCustomSection( $sectionName )
		return
	end
	
 	idx = 0
 	#html += spreader()
 	html += "<table>"
	songList.each do |item|
		rating = item[0].to_i()
		score = item[1].to_i()
		title = item[2]
		url = item[3]
		
		html += 	"<tr>"
		html += 		"<td valign=center style='width:30em;'>#{title}</td>"
		#html +=			"<td>&nbsp;</td>"
		#html +=			"<td>#{spreader(100)}</td>"
		html +=			"<td valign=center align=right>"
		
			# rating
		rate = AMAROK.getScore().to_i()
		html += 	"<table border='0' cellspacing='0' cellpadding='0' width='100%'>"
		html += 		"<tr align=left title='Score: #{rating}'>"
		html +=				"<td class='sbtext' align=left>#{rating}&nbsp;&nbsp;</td>"
		html +=				"<td align=left width='1'>"
		html +=					"<div class='sbouter'>"
		html +=					  "<div class='sbinner' style='width: #{rating / 2}px'></div>"
		html +=					"</div>"
		html +=				"</td>"
		html +=			"</tr>"
		
		# score
		score = AMAROK.getRating().to_i()
		big_star = 
		"<image height='13px' class=ratingStar src='file://#{datadir}/amarok/images/star.png'>"
		small_star = 
		"<image height='13px' class=ratingStar src='file://#{datadir}/amarok/images/smallstar.png'>"
		
		# start the rating
		html += 		"<tr title='Rating: #{score.to_f() / 2.0 }'>"
		html += 			"<td class='ratingBox' align='right' colspan='2'>"
		html += 				"<nobr>"
		
		# generate the rating stars
		if score == 0
			html += "Not rated"
		end	
		while score > 2 do
			html += big_star
			score = score - 2
		end
		if score > 1
			html += big_star
		end
	
		# close
		html +=					"</nobr>"
		html +=				"</td>"
		html += 		"</tr>"
		html += 	"</table>"
		
		html +=		"</td>"
		html +=		"<td style='width:0.25em'></td>"
		html +=		"</td>"
		html +=	"</tr>"
		
	end
	html += "</table>"
	
	AMAROK.setCustomSection( $sectionName, html )
end

# update the information when the script is run
showTrackInfo()

loop do
    message = gets().chomp()
    command = /[A-Za-z]*/.match( message ).to_s()

    case command
    	when "trackChange"
    		showTrackInfo()
    end
end