#!/usr/bin/ruby -I/home/teknomunk/.kde/share/apps/amarok/

require "amarok"

# initilization on load
$sectionName = "0 external_track_info"
AMAROK.addCustomSection( $sectionName )
AMAROK.setCustomSectionContext( $sectionName, "track" )

def showTrackInfo()
	# get the song's information from amarok
	artist = AMAROK.getArtist()
	album = AMAROK.getAlbum()
	title = AMAROK.getTitle()
	
	# set the section name
	AMAROK.setCustomSectionTitle( $sectionName, "<b>#{title}</b> - #{artist}<br>#{album}" )
	
	html = ""
	
	# cover art
	html += "<div>\n"
	html += "	<table width=100% align=left><tr>\n"
	html += "		<td align=left>\n"
	html += "			<img src=\"#{AMAROK.getCoverArt().strip()}\"/>\n"
	html += "		</td>\n"
	html += "		<td align=left valign=bottom width=100%>\n"
	
	# the data directory TODO: need to detect from amarok
	datadir = "/usr/share/apps/"
	
	# a table containing the whole
	html += "			<table align=right ><tr><td align=right>"
	
	# force the box to fill the entire width of the box, even after collapsing
	#html += "&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "
	
	# music brainz link
	html += "				<a id='musicbrainz-a' title='Look up this track at musicbrainz.org' \n"
	html += "					 href='musicbrainz:#{AMAROK.getArtist().strip()} @@@ #{AMAROK.getAlbum().strip()} @@@ #{AMAROK.getTitle().strip()}'>\n"
	html +=	"					<img id='musicbrainz-image' src='#{datadir}amarok/images/musicbrainz.png'/>\n"
	html += "				</a><br>\n"
	
	# play count
	played = AMAROK.getPlayCount().to_i()
	if played != 0
		html += "				<nobr>This song has been </nobr><nobr>played #{played} times.</nobr><br>\n"
	else
		html += "				<nobr>Never played before.</nobr><br>\n"
	end
	
	# rating
	rate = AMAROK.getScore().to_i()
	html += "				<table border='0' align=left cellspacing='0' cellpadding='0' width='100%'>\n"
	html += "					<tr align=left title='Score: #{rate}'>\n"
	#html +=	"						<td> </td>\n"
	html +=	"						<td class='sbtext' align=right>#{rate}&nbsp;&nbsp;</td>\n"
	html +=	"						<td align='left' align=left width='1'>\n"
	html +=	"							<div align=left class='sbouter'>\n"
	html +=	"							<div align=left class='sbinner' style='width: #{rate / 2}px'></div>\n"
	html +=	"						</div>\n"
	html +=	"					</td>\n"
	html +=	"				</tr>\n"
	
	# score
	score = AMAROK.getRating().to_i()
	big_star = 
	"<image height='13px' class=ratingStar src='file://#{datadir}/amarok/images/star.png'>"
	small_star = 
	"<image height='13px' class=ratingStar src='file://#{datadir}/amarok/images/smallstar.png'>"
	
	# start the rating
	html += "				<tr title='Rating: #{score.to_f() / 2.0 }'>\n"
	html += "					<td class='ratingBox' align='right' colspan='2'>\n"
	html += "						<nobr>\n"
	
	# generate the rating stars
	if score == 0
		html += "Not rated"
	end	
	while score > 2 do
		html += big_star
		score = score - 2
	end
	if score > 1
		html += big_star
	end

	# close
	html +=	"						</nobr>\n"
	html +=	"					</td>\n"
	html += "				</tr>\n"
	html += "			</table>\n"
	
	# comment
	html += "			<br><br><i>#{AMAROK.getComment()}</i><br>\n"
	
	# close everything up
	html += "			</td>\n"
	html += "		</tr></table>\n"
	html += "	</td></tr></table>\n"
	html += "</div>\n"
	#html += "<td>test</td>"
	
	AMAROK.setCustomSection( $sectionName, html )
end

# update the information when the script is run
showTrackInfo()

loop do
    message = gets().chomp()
    command = /[A-Za-z]*/.match( message ).to_s()

    case command
    	when "trackChange"
    		showTrackInfo()
    end
end