#!/usr/bin/ruby -I/home/teknomunk/.kde/share/apps/amarok/

require "amarok"

# initilization on load
$sectionName = "lastfm_similar_artists"
AMAROK.addCustomSection( $sectionName )
AMAROK.setCustomSectionContext( $sectionName, "track" )

def curl( url )
	return `curl "#{url}" 2>/dev/null`
end

def fetchSimilarArtists()
	# provide feedback to the user while we do out work
	AMAROK.setCustomSection( $sectionName, "Loading..." )

	# fetch current data for the song
	artist = AMAROK.getArtist().strip()
	title = AMAROK.getTitle().strip()
	
	# set the section title to something more meaningful
	AMAROK.setCustomSectionTitle( $sectionName, "Last.fm - Artist Similar to #{artist}" )
	
	# check the cache
	key="lastfm-similarartists-#{artist}"
	res = AMAROK.getCache(key).strip()
	if res.to_s() != ""
		AMAROK.setCustomSection(sectionName,res)
		return
	end
	
	# remove spaces, url's don't like them
	artist.gsub!(" ","+")
	title.gsub!(" ","+")
	artist.gsub!("&","%2526")
	title.gsub!("&","%2526")
	
	# query the page
	body = curl("http://www.last.fm/music/#{artist}/+similar")
	if body == nil or body == ""
		AMAROK.clearCustomSection( $sectionName )
		return
	end
	
	# pull the names out of the body of the text
	names = body.scan( /<a title="(.*?)"/ )
	
	if names != nil and names.size > 0
		
		# possible add links here
		
		# join all the names together
		artists = []
		names.each do |name|
			artists.push(name)
		end
		html = artists.join(", ")
		
		# hand off to amarok
		AMAROK.setCustomSection( $sectionName, html )
		AMAROK.setCache( key, html )
		return
	end
	
	# failed to work
	AMAROK.clearCustomSection( $sectionName )
end

loop do
    message = gets().chomp()
    command = /[A-Za-z]*/.match( message ).to_s()

    case command
    	when "trackChange"
    		fetchSimilarArtists()
    end
end