#!/usr/bin/ruby -I/home/teknomunk/.kde/share/apps/amarok/

require "amarok"
require "cgi"
require "iconv"

# initilization on load
$sectionName = "lastfm_suggested_songs"
AMAROK.addCustomSection( $sectionName )
AMAROK.setCustomSectionContext( $sectionName, "track" )

def curl( url )
	return `curl "#{url}" 2>/dev/null`
end

def fetchSuggestedSongs()
	# provide feedback to the user while we do out work
	AMAROK.setCustomSection( $sectionName, "Loading...." )

	# fetch current data for the song
	artist = AMAROK.getArtist().strip()
	title = AMAROK.getTitle().strip()
	
	artist_orig = artist
	title_orig = title
	
	# set the section title to something more meaningful
	AMAROK.setCustomSectionTitle( $sectionName, "Last.fm - Suggested Songs" )
	
	# check the cache
	key="#{$sectionName}-#{artist}"
	page_key = "#{key}-page"
	#res = AMAROK.getCache(key).strip()
	#if res.to_s() != ""
	#	AMAROK.setCustomSection(sectionName,res)
	#	return
	#end
	
	# remove spaces, url's don't like them
	artist.gsub!(" ","+")
	title.gsub!(" ","+")
	artist.gsub!("&","%2526")
	title.gsub!("&","%2526")
	
	# query the page
	body = AMAROK.getCache(page_key).strip()
	if body.to_s() == ""
		body = curl("http://www.last.fm/music/#{artist}/+similar")
		if body == nil or body == ""
			AMAROK.clearCustomSection( $sectionName )
			return
		end
		
		AMAROK.setCache( page_key, body )
	end
	
	# pull the names out of the body of the text
	names = body.scan( /<a title="(.*?)"/ )
	
	if names != nil and names.size > 0
		
		# possible add links here
		
		# join all the names together
		artists = []
		names.each do |name|
			artists.push(name)
		end
		
		html = ""
		
		# enclose in quotes
		artists.collect! { |x| "\"#{x}\"" }
		
		sql = "SELECT tags.title,artist.name,tags.url FROM tags,artist WHERE tags.artist=artist.id and artist.name IN (#{artists.join(",")},\"#{artist_orig}\") and tags.title != \"#{title_orig.gsub("\"","&quot;")}\" ORDER BY RANDOM() LIMIT 15"
		puts sql
		result = AMAROK.query( sql ).split("\n")
		
		if result.size() < 3
			AMAROK.clearCustomSection( $sectionName )
			return
		end
		
		result = result.group(3)
		
		html += "<table>"
		
		result.each do |item|
			if item.size() == 3
				title = item[0]
				artist = item[1]
				url = item[2]
				
				artist_uni = artist
				
				html += "<tr><td><a href=\"file://#{url}\"><nobr>#{artist_uni} ー #{title}</nobr></a></td>"
			end
		end
		
		html += "</table>"
		
		# hand off to amarok
		AMAROK.setCustomSection( $sectionName, html )
		AMAROK.setCache( key, html )
		return
	end
	
	# failed to work
	AMAROK.clearCustomSection( $sectionName )
end

fetchSuggestedSongs()

loop do
    message = gets().chomp()
    command = /[A-Za-z]*/.match( message ).to_s()

    case command
    	when "trackChange"
    		fetchSuggestedSongs()
    end
end